// BERT.CPP - Bit Error Rate Tester (2FSK-Version)
// --------------------------------------------------------------------------
// (C) 2.4.1997 Jrgen Hasch, DG1SCR@DB0RBS (hasch@t-online.de)
// V1.1

#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <iostream.h>
#include <ctype.h>
#include <string.h>

#include "rs232.hpp"

#define TRUE     1
#define FALSE    0
#define WAITTIME 100
#define MAXGAIN  16
#define PGUP     73
#define PGDOWN   81
#define STEP 0.1
static RS232 *com;

int verbose = FALSE;    // keine Meldungen ausgeben
int poly1[10],poly2[10],poly3[10],poly4[10];

int buf[64];
int *buf1= (buf+1);
int buf2[32];
int buf3[32];
char *fs;            // Wandlungsfrequenz
double ts;           // Periode
int OFFSET = -70;      // DC-Offset
double SCALE = 1.5;  // Skalierung
int mono=FALSE;      // Monochrom-Modus
int pause=FALSE;

int c2n(char c)
{
int n;
  n = c - 0x30;
  if (n > 9)
    n = _toupper(c) - 'A' + 10;
  return n;
}

//
// hex-string in zahl umwandeln (1,2 oder 3-stellig)
//
int hex2i(char *str)
{
int len;

  len = strlen(str);
 if (len == 1)
   return c2n(*str);
 if (len == 2)
   return 16*c2n(*str) + c2n(*(str+1));
 if (len == 3)
   return 256*c2n(*str) + 16*c2n(*(str+1)) + c2n(*(str+2));
 return 0;
}
//
// Bildschirmmaske aufbauen
//
void initbs()
{
char tmp[80];
int x,y,i;

  setcolor(BLUE);
  cleardevice();
  setcolor(WHITE);
  // Rahmen
  lineto(639,0); lineto(639,479); lineto(0,479); lineto(0,0);
  line(0,20,639,20);
  line(0,21,639,21);
  outtextxy(20,7,"BERT V1.0");

  outtextxy(100,27,"Received Signal");
//  outtextxy(200,222,"Level decision");
  outtextxy(100,222,"Decision amplitudes");

  poly1[0] = 40 ; poly2[0] = 40 ; poly3[0] = 320; poly4[0] = 360;
  poly1[1] = 40 ; poly2[1] = 240; poly3[1] = 240 ; poly4[1] = 240;
  poly1[2] = 40 ; poly2[2] = 40 ; poly3[2] = 320; poly4[2] = 360;
  poly1[3] = 200; poly2[3] = 400; poly3[3] = 400; poly4[3] = 400;
  poly1[4] = 621; poly2[4] = 621; poly3[4] = 620; poly4[4] = 582;
  poly1[5] = 200; poly2[5] = 400; poly3[5] = 400; poly4[5] = 400;
  poly1[6] = 621; poly2[6] = 621; poly3[6] = 620; poly4[6] = 582;
  poly1[7] = 40 ; poly2[7] = 240; poly3[7] = 240; poly4[7] = 240;
  poly1[8] = 40 ; poly2[8] = 40 ; poly3[8] = 320; poly4[8] = 360;
  poly1[9] = 40 ; poly2[9] = 240; poly3[9] = 240; poly4[9] = 240;

  if (!mono)
   {
    setcolor(LIGHTBLUE);
    fillpoly(4,poly1);
    fillpoly(4,poly2);
//    fillpoly(4,poly3);
    setcolor(WHITE);
    }
  drawpoly(5,poly1);
  drawpoly(5,poly2);
//  drawpoly(5,poly3);

  if (!mono) setcolor(YELLOW);
  setlinestyle(1,0,NORM_WIDTH);
  line(41, 120, 620,120); // Null-Linie
  line(41, 320, 620,320); // Null-Linie
  for (i=0; i < 6; i++)
    {
    line(56+5*i*20,41,56+5*i*20,199);
    line(56+5*i*20,241,56+5*i*20,399);
    }
  setlinestyle(0,0,NORM_WIDTH);
  setcolor(WHITE);

  outtextxy(15,120,"0");
  outtextxy(10,195,"-1");
  outtextxy(15,45,"1");

  outtextxy(15,320,"0");
  outtextxy(10,395,"-1");
  outtextxy(15,245,"1");

}

//
// Daten empfangen und auf Bildschirm darstellen
//
void display()
{
int xpos,i,k,rx_i,rx_q,px,py;
char c1,c2,c3;
char tmp[40];
unsigned int bitcnt1,bitcnt2,bitcnt3;
unsigned int errcnt1,errcnt2,errcnt3;
unsigned long bitcnt, errcnt;
double f;

  com->flushInBuf();
  com->txchar('S');
  delay(10);
  
//  setcolor(LIGHTBLUE);
//  line(41,120-buf1[0],51,120-buf1[1]);
  
  bitcnt1 = com->rxchar() & 0xff;  
  bitcnt2 = com->rxchar() & 0xff;  
  bitcnt3 = com->rxchar() & 0xff;  
 
  errcnt1 = com->rxchar() & 0xff;  
  errcnt2 = com->rxchar() & 0xff;  
  errcnt3 = com->rxchar() & 0xff;  

  gotoxy(15,1);
  errcnt = 65536 * errcnt3 + 256 * errcnt2 + errcnt1;
  bitcnt = 65536 * bitcnt3 + 256 * bitcnt2 + bitcnt1;
  // Fehlerhufigkeit
  if (bitcnt > 0)
    f = (double)errcnt / (double)bitcnt;
  printf("Scale: %03f Bits: %02x%02x%02x Err: %02x%02x%02x P: %05f",SCALE, bitcnt3,bitcnt2,bitcnt1,errcnt3,errcnt2,errcnt1,f);

  setcolor(WHITE);
  buf2[0] = buf2[1]; buf3[0]=buf3[1];
//  buf[0] = -buf1[0];
  for (i=0; i < 6; i++)
    {
    for (k=0; k < 5; k++)
      {    
      c1 = com->rxchar();
      buf1[k+5*i] = (int) ( (double)c1*0.9 );    
      if (k==0 && i==0)
       ; // skip first
      else
        line(20+(k+5*i)*20,120-buf1[k+5*i-1],40+(k+5*i)*20,120-buf1[k+5*i]);
      }
   
    c1 = com->rxchar();
    buf3[i+1] = (int) ( (double)c1*SCALE )+OFFSET;    
    c1 = com->rxchar();
//    buf3[i+1] = (int) ( (double)c1*SCALE );    
    
//    line(31+i*40,320-buf2[i],70+i*40,320-buf2[i+1]);
//    line(321+i*40,380-buf3[i],360+i*40,380-buf3[i+1]);
//   if (i==0)
//     ; // skip first
//   else
//    line(55+20*5*(i-1),320-buf3[i-1],55+20*5*i,320-buf3[i]);
    line(53+20*5*i,318-buf3[i],57+20*5*i,322-buf3[i]);
    line(57+20*5*i,318-buf3[i],53+20*5*i,322-buf3[i]);
    setcolor(WHITE);
    }
 delay(10);
}
//

//
// Daten abspeichern
//
void save()
{
FILE *fout;
double t;
int i;

  fout=fopen("waveform.dat","w");
  fprintf(fout,"Zeit [s]  Wert[-128...127]\n");
  for (i=0; i < 30 ; i++)
    {
    t = (double)i * ts;
    fprintf(fout," %e  %i\n", t, buf1[i]);
    }
 fclose(fout);

}

void usage()
{
  cout << "BERT - Bit Error Rate Tester\n";
  cout << "Parameter: -m -v -c<comport> [oder -b<portaddr> -i<irq>]\n";
  exit(0);
}

int main(int argc, char *argv[])
{
  int gdriver = DETECT, gmode, errorcode;
  char key,c;
  int quit,i;
  int portaddr = 0, portint = 0;
  int comport = 0;

  if (argc > 1)
    {
    i = argc;
    while (--i > 0)
      {
      c = _toupper(*(argv[i]+1));
      if (*argv[i] == '-')
	switch(c)
	  {
	  case '?':
	   usage();
	   break;
	  case 'B':
	    portaddr = hex2i(argv[i]+2);
	    break;
	  case 'I':
	    portint = hex2i(argv[i]+2);
	    break;
          case 'M':
            mono = TRUE;
            break;
	  case 'C':
	     comport = *(argv[i]+2) - 0x30;
	     if (comport < 1 || comport > 4)
	       {
	       cout << "Falsche Angabe : " << argv[i] << "\n";
	       exit(0);
	       }
	   break;
	  case 'V':
	    verbose = TRUE;
	    break;
	  default:
	    cout << "Falscher Parameter: " << argv[i] << "\n";
	    cout << "OSZI -? fr Hilfe\n";
	    exit(0);
	  } // switch
	} // while
      } // if
   else
     usage();

 if (verbose)
  {
  cout << "Comport:   " << comport << "\n";
  cout << "Portaddr:  " << portaddr << "\n";
  cout << "Interrupt: " << portint << "\n";
  }

 if (comport > 0 && portaddr == 0 && portint == 0)
    com = new RS232((unsigned char)comport);
 else
    com = new RS232(38400, portaddr, portint); // COM-Port ffnen
 com->setBaud(38400L);

//  delay(1000);       // warten bis DSP-Karte bereit

  com->flushInBuf();
  // Programm laden
  // und ausfhren...
//  delay(10*WAITTIME);

  initgraph(&gdriver, &gmode, "");

  errorcode = graphresult();
  if (errorcode != grOk)
    {
    printf("Grafik-Fehler: %s\n", grapherrormsg(errorcode));
    printf("...Tastendruck beendet das Programm!");
    delete com;
    getch();
    exit(1);
    }

  setfillstyle(SOLID_FILL,LIGHTBLUE);
 initbs();
 moveto(100,250);

  quit = 0;
  ts = 1.0/48000.0;

  while (!quit)
    {
    if (!pause);
      display();
    if (kbhit())
      {
      key = getch();
      switch(toupper(key))
	{
	case '+':
	  OFFSET += 5;
	  break;
	case '-':
	  OFFSET -=5; 
	  break;
	case PGUP:
	  if (SCALE < 2.0)
	    SCALE+=STEP;
	  break;
	case PGDOWN:
	  if (SCALE > STEP)
	    SCALE-=STEP;
	  break;
	case 'R':
	  initbs();
	  break;
	case 'S':
	  save();
	  break;
	case 'X':
	  quit = 1;
	  break;
        case 'P':
          if (pause)
            pause=FALSE;
          else
            pause=TRUE;
          break;
	}
      }
   }
   closegraph();
   delete com;
   return 0;
}
